'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-60abc172.js');

const myComponentCss = "input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=\"number\"]{-moz-appearance:textfield}.emptyDiv{width:100%;height:10%}.flex-container{display:-ms-flexbox;display:flex;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-ms-flex-pack:center;justify-content:center;width:100%}.flex-container>input{width:8px;margin:5px;padding:20px}.otpInput{padding:3px;text-align:center;line-height:25px;font-size:22px;background-color:#ccc}body{display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;-ms-flex-direction:column;flex-direction:column}.digit-group input{width:25px;height:40px;background-color:#18182a;border:none;line-height:50px;text-align:center;font-size:24px;font-family:\"Raleway\", sans-serif;font-weight:200;color:white;margin:0 2px}.digit-group .splitter{padding:0 5px;color:white;font-size:24px}.prompt{margin-bottom:20px;font-size:20px;color:white}.emailMobile{text-align:left}#idk{color:black !important}button{height:38px;width:200px;border-radius:5px !important;border:none;color:black}#emptySpace{width:200px}.buttonsGroup{display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;width:100%;-ms-flex-direction:row;flex-direction:row}.emailandphone{font-size:18px;text-align:left;padding-left:1%}.form-check-input{margin-top:12px}.emailButton{margin:4%;background-color:#007bff;border:none;color:white;padding:6px 32px;text-align:center;text-decoration:none;display:inline-block;font-size:16px}.emptySpace{width:0px}.emailphonecenter{text-align:center}.errormsg{margin-top:2%;color:red}body{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column}*{}.digit-group input{width:40px;height:40px;background-color:silver;border:none;line-height:50px;text-align:center;font-size:24px;font-family:\"Raleway\", sans-serif;margin:0 2px}.digit-group .splitter{padding:0 5px;color:white;font-size:24px}.prompt{margin-bottom:20px;font-size:20px;color:white}.splitter{color:black !important}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=\"number\"]{-moz-appearance:textfield}.emptyDiv{width:100%;height:10%}.flex-container{display:-ms-flexbox;display:flex;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-ms-flex-pack:center;justify-content:center;width:100%;margin-top:3%}.flex-container button{margin-right:50px;margin-left:30px}.flex-container>input{width:80px;margin:5px;padding:20px}.otpInput{padding:3px;text-align:center;line-height:25px;font-size:22px;background-color:#ccc}#backgroundOtp{height:150px}";

const otpcomponent = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.step1_heading = "Identity verification";
        this.step1_headingSP = "Verificación de identidad";
        this.step1_instruction = "Select the information that you can confirm:";
        this.step1_instructionSP = "Seleccione la información que puede confirmar:";
        this.step1_description = "Please take a moment to verify your identity. This helps us confirm your identity and keep your account secured.";
        this.step1_descriptionSP = "Tómese un momento para verificar su identidad. Esto nos ayuda a confirmar su identidad y mantener segura su cuenta.";
        this.step2_heading = "Code verification";
        this.step2_headingSP = "Verificación de código";
        this.toggle = false;
        this.sendOTP = null;
        this.errorMessage = null;
        this.emailList = [];
        this.phoneNoList = [];
        this.redirectTo = false;
        this.otpCode = null;
        this.errorOTP = "";
        this.otpValue = [];
        this.checkToMove = false;
        this.step2_instruction = `Please enter the ${this.size} digit code below`;
        this.step2_instructionSP = `Ingrese el código de ${this.size} dígitos a continuación`;
    }
    parseMyArrayPropTo(newValue) {
        if (newValue)
            this.myInnerStrings = JSON.parse(newValue);
    }
    componentWillLoad() {
        this.parseMyArrayPropTo(this.input);
        for (let i = 0; i < this.myInnerStrings.length; i++) {
            if (this.myInnerStrings[i].includes("@")) {
                this.emailList.push(this.myInnerStrings[i]);
            }
            else {
                this.phoneNoList.push(this.myInnerStrings[i]);
            }
        }
    }
    firstPage() {
        this.pageFirst();
    }
    setValue(event) {
        this.sendOTP = JSON.stringify(event.target.value);
    }
    check() {
        if (this.sendOTP === "" || this.sendOTP === null) {
            if (this.language === "en") {
                this.errorMessage = "Please select your identity";
            }
            else {
                this.errorMessage = "Por favor seleccione su identidad";
            }
        }
        else {
            this.handleOtp();
            this.errorMessage = "";
            this.redirectTo = true;
        }
    }
    pageFirst() {
        this.redirectTo = false;
    }
    async handleOtp() {
        try {
            let response = await fetch(this.api, {
                headers: {
                    emailOrMobile: this.sendOTP,
                },
            });
            let json = await response.json();
            console.log(json);
        }
        catch (err) {
            console.log(err);
        }
    }
    async verifyOTP() {
        if (this.otpCode === "" || this.otpCode === null) {
            if (this.language === "en") {
                this.errorOTP = "Please enter OTP";
            }
            else {
                this.errorOTP = "Por favor, introduzca OTP";
            }
        }
        else {
            var ognum = this.otpValue.join("");
            try {
                let response = await fetch(this.name, {
                    headers: {
                        optValue: ognum,
                    },
                });
                let json = await response.json();
                if (json === "Otp Verified 1234") {
                    console.log("Verified ");
                    this.callBack();
                }
                else {
                    console.log("NOT Verified MF");
                }
            }
            catch (err) {
                console.log(err);
            }
        }
        this.callBack();
    }
    setOTPValue(event) {
        if (this.checkToMove) {
            this.checkToMove = false;
        }
        else {
            this.otpCode = event.target.value;
            var code = event.target.id;
            this.otpValue[code] = event.target.value;
            var hj = parseInt(code);
            var code2 = hj + 1;
            if (code2 <= parseInt(this.size)) {
                document.getElementById(`${code2}`).focus();
            }
        }
    }
    goBack() {
        this.redirectTo = false;
    }
    maskedEmail(emailID) {
        var avg, splitted, part1, part2;
        splitted = emailID.split("@");
        part1 = splitted[0];
        var totalLength = part1.length - 2;
        var hide = "";
        for (let i = 0; i < totalLength; i++) {
            hide = hide + "X";
        }
        avg = part1.substring(0, 2);
        part2 = splitted[1];
        var result = avg + hide + "@" + part2;
        return result;
    }
    phoneMasked(data) {
        var afterSplit = data.split("-");
        var result = "XXX-XXX-" + afterSplit[2];
        return result;
    }
    render() {
        window.addEventListener("keydown", (e) => {
            if (e.keyCode == 8 || e.keyCode == 46) {
                this.checkToMove = true;
            }
        });
        const textStyle = {
            color: this.color,
            fontFamily: this.fontfamily,
            fontSize: this.headingfontsize,
            fontWeight: "500",
        };
        const line = {
            borderBottomStyle: "solid",
            borderBottomWidth: "thin",
            borderBottomColor: "#d3d3d3",
            width: "99%",
            marginBottom: "20px",
        };
        const contentStyle = {
            fontFamily: this.fontfamily,
            color: this.color,
            fontSize: this.textfontsize,
        };
        const buttonStyle = {
            backgroundColor: this.color,
            fontFamily: this.fontfamily,
            borderColor: this.color,
            fontSize: this.textfontsize,
        };
        const innerContent = {
            fontFamily: this.fontfamily,
            marginLeft: "10px",
        };
        const inputStyle = {
            border: `${this.color} 1.5px solid`,
            fontSize: `${this.textfontsize} !important`,
            fontFamily: this.fontfamily,
        };
        const errorStyle = {
            fontSize: this.textfontsize,
            fontFamily: this.fontfamily,
        };
        var vectorInput = [];
        var num = parseInt(this.size);
        for (var i = 0; i < num; i++) {
            var inName = `${i}`;
            if (i === num - 1) {
                vectorInput.push(index.h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" }, index.h("input", { type: "text", onInput: (e) => this.setOTPValue(e), style: inputStyle, id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" })));
            }
            else {
                vectorInput.push(index.h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" }, index.h("input", { type: "text", style: inputStyle, onInput: (e) => this.setOTPValue(e), id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" }), index.h("span", { class: "splitter" }, "\u2013")));
            }
        }
        let displayEmail = this.emailList.map((value) => (index.h("div", { class: value }, index.h("lab", { htmlFor: value }, index.h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: (e) => this.setValue(e), style: inputStyle }), this.maskedEmail(value)))));
        let displayPhone = this.phoneNoList.map((value) => (index.h("div", { class: value }, index.h("lab", { htmlFor: value }, index.h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: (e) => this.setValue(e), style: inputStyle }), this.phoneMasked(value)))));
        return (index.h("div", null, this.redirectTo === true ? (index.h("div", null, index.h("center", null, index.h("h3", { class: "" }, this.language === "en" ? (index.h("span", { style: textStyle }, this.step2_heading)) : (index.h("span", { style: textStyle }, this.step2_headingSP)))), index.h("div", { class: "lineClass", style: line }), index.h("center", null, this.language === "en" ? (index.h("div", { style: contentStyle }, this.step2_instruction)) : (index.h("div", { style: contentStyle }, this.step2_instructionSP))), index.h("div", { class: "row mt-4" }, index.h("div", { class: "flex-container" }, vectorInput)), index.h("center", { class: "errormsg", style: errorStyle }, this.errorOTP !== null ? index.h("p", null, this.errorOTP) : null), index.h("center", null, index.h("div", { class: "buttonsGroup" }, index.h("button", { class: "emailButton", style: buttonStyle, onClick: this.goBack.bind(this) }, this.language === "en" ? index.h("a", null, "Previous") : index.h("a", null, "Previo")), index.h("button", { class: "emailButton", style: buttonStyle, onClick: this.verifyOTP.bind(this) }, this.language === "en" ? (index.h("a", null, "Verify now")) : (index.h("a", null, "Verifica ahora"))))), index.h("center", null, index.h("a", { href: "#", style: contentStyle, onClick: () => this.firstPage() }, this.language === "en" ? (index.h("a", null, "Resend code")) : (index.h("a", null, "Reenviar codigo")))))) : (index.h("div", { class: "container mt-5" }, index.h("center", null, index.h("h1", { style: textStyle }, this.language === "en" ? (index.h("span", null, this.step1_heading)) : (index.h("span", null, this.step1_headingSP)))), index.h("div", { style: line }), index.h("center", null, index.h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (index.h("span", null, this.step1_description)) : (index.h("span", null, this.step1_descriptionSP)))), index.h("center", null, index.h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (index.h("span", null, this.step1_instruction)) : (index.h("span", null, this.step1_instructionSP)))), index.h("center", null, index.h("div", { class: "flex-container" }, index.h("div", { class: "emailandphone", style: innerContent }, displayEmail, displayPhone))), index.h("center", { class: "errormsg" }, this.errorMessage !== "" || this.errorMessage !== null ? (index.h("p", null, this.errorMessage)) : null), index.h("center", null, index.h("div", { class: "buttonsGroup" }, index.h("button", { class: "emailButton", style: buttonStyle }, this.language === "en" ? (index.h("span", null, "Previous")) : (index.h("span", null, "Previo"))), index.h("button", { class: "emailButton", style: buttonStyle, onClick: this.check.bind(this) }, this.language === "en" ? (index.h("span", null, "Send OTP")) : (index.h("span", null, "Enviar OTP"))))), index.h("center", null, index.h("a", { style: contentStyle, href: "#" }, this.language === "en" ? (index.h("span", null, "I don't see my number or email")) : (index.h("span", null, "No veo mi n\u00FAmero o correo electr\u00F3nico"))))))));
    }
    static get watchers() { return {
        "input": ["parseMyArrayPropTo"]
    }; }
};
otpcomponent.style = myComponentCss;

exports.otp_web_component = otpcomponent;
