import { h, Component, Prop, State, Listen, Watch } from "@stencil/core";
export class otpcomponent {
    constructor() {
        this.step1_heading = "Identity verification";
        this.step1_headingSP = "Verificación de identidad";
        this.step1_instruction = "Select the information that you can confirm:";
        this.step1_instructionSP = "Seleccione la información que puede confirmar:";
        this.step1_description = "Please take a moment to verify your identity. This helps us confirm your identity and keep your account secured.";
        this.step1_descriptionSP = "Tómese un momento para verificar su identidad. Esto nos ayuda a confirmar su identidad y mantener segura su cuenta.";
        this.step2_heading = "Code verification";
        this.step2_headingSP = "Verificación de código";
        this.toggle = false;
        this.sendOTP = null;
        this.errorMessage = null;
        this.emailList = [];
        this.phoneNoList = [];
        this.redirectTo = false;
        this.otpCode = null;
        this.errorOTP = "";
        this.otpValue = [];
        this.checkToMove = false;
        this.step2_instruction = `Please enter the ${this.size} digit code below`;
        this.step2_instructionSP = `Ingrese el código de ${this.size} dígitos a continuación`;
    }
    parseMyArrayPropTo(newValue) {
        if (newValue)
            this.myInnerStrings = JSON.parse(newValue);
    }
    componentWillLoad() {
        this.parseMyArrayPropTo(this.input);
        for (let i = 0; i < this.myInnerStrings.length; i++) {
            if (this.myInnerStrings[i].includes("@")) {
                this.emailList.push(this.myInnerStrings[i]);
            }
            else {
                this.phoneNoList.push(this.myInnerStrings[i]);
            }
        }
    }
    firstPage() {
        this.pageFirst();
    }
    setValue(event) {
        this.sendOTP = JSON.stringify(event.target.value);
    }
    check() {
        if (this.sendOTP === "" || this.sendOTP === null) {
            if (this.language === "en") {
                this.errorMessage = "Please select your identity";
            }
            else {
                this.errorMessage = "Por favor seleccione su identidad";
            }
        }
        else {
            this.handleOtp();
            this.errorMessage = "";
            this.redirectTo = true;
        }
    }
    pageFirst() {
        this.redirectTo = false;
    }
    async handleOtp() {
        try {
            let response = await fetch(this.api, {
                headers: {
                    emailOrMobile: this.sendOTP,
                },
            });
            let json = await response.json();
            console.log(json);
        }
        catch (err) {
            console.log(err);
        }
    }
    async verifyOTP() {
        if (this.otpCode === "" || this.otpCode === null) {
            if (this.language === "en") {
                this.errorOTP = "Please enter OTP";
            }
            else {
                this.errorOTP = "Por favor, introduzca OTP";
            }
        }
        else {
            var ognum = this.otpValue.join("");
            try {
                let response = await fetch(this.name, {
                    headers: {
                        optValue: ognum,
                    },
                });
                let json = await response.json();
                if (json === "Otp Verified 1234") {
                    console.log("Verified ");
                    this.callBack();
                }
                else {
                    console.log("NOT Verified MF");
                }
            }
            catch (err) {
                console.log(err);
            }
        }
        this.callBack();
    }
    setOTPValue(event) {
        if (this.checkToMove) {
            this.checkToMove = false;
        }
        else {
            this.otpCode = event.target.value;
            var code = event.target.id;
            this.otpValue[code] = event.target.value;
            var hj = parseInt(code);
            var code2 = hj + 1;
            if (code2 <= parseInt(this.size)) {
                document.getElementById(`${code2}`).focus();
            }
        }
    }
    goBack() {
        this.redirectTo = false;
    }
    maskedEmail(emailID) {
        var avg, splitted, part1, part2;
        splitted = emailID.split("@");
        part1 = splitted[0];
        var totalLength = part1.length - 2;
        var hide = "";
        for (let i = 0; i < totalLength; i++) {
            hide = hide + "X";
        }
        avg = part1.substring(0, 2);
        part2 = splitted[1];
        var result = avg + hide + "@" + part2;
        return result;
    }
    phoneMasked(data) {
        var afterSplit = data.split("-");
        var result = "XXX-XXX-" + afterSplit[2];
        return result;
    }
    render() {
        window.addEventListener("keydown", (e) => {
            if (e.keyCode == 8 || e.keyCode == 46) {
                this.checkToMove = true;
            }
        });
        const textStyle = {
            color: this.color,
            fontFamily: this.fontfamily,
            fontSize: this.headingfontsize,
            fontWeight: "500",
        };
        const line = {
            borderBottomStyle: "solid",
            borderBottomWidth: "thin",
            borderBottomColor: "#d3d3d3",
            width: "99%",
            marginBottom: "20px",
        };
        const contentStyle = {
            fontFamily: this.fontfamily,
            color: this.color,
            fontSize: this.textfontsize,
        };
        const buttonStyle = {
            backgroundColor: this.color,
            fontFamily: this.fontfamily,
            borderColor: this.color,
            fontSize: this.textfontsize,
        };
        const innerContent = {
            fontFamily: this.fontfamily,
            marginLeft: "10px",
        };
        const inputStyle = {
            border: `${this.color} 1.5px solid`,
            fontSize: `${this.textfontsize} !important`,
            fontFamily: this.fontfamily,
        };
        const errorStyle = {
            fontSize: this.textfontsize,
            fontFamily: this.fontfamily,
        };
        var vectorInput = [];
        var num = parseInt(this.size);
        for (var i = 0; i < num; i++) {
            var inName = `${i}`;
            if (i === num - 1) {
                vectorInput.push(h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" },
                    h("input", { type: "text", onInput: (e) => this.setOTPValue(e), style: inputStyle, id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" })));
            }
            else {
                vectorInput.push(h("form", { method: "get", class: "digit-group", "data-group-name": "digits", "data-autosubmit": "false", autocomplete: "off" },
                    h("input", { type: "text", style: inputStyle, onInput: (e) => this.setOTPValue(e), id: inName, name: "digit-1", "data-next": "digit-2", maxlength: "1" }),
                    h("span", { class: "splitter" }, "\u2013")));
            }
        }
        let displayEmail = this.emailList.map((value) => (h("div", { class: value },
            h("lab", { htmlFor: value },
                h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: (e) => this.setValue(e), style: inputStyle }),
                this.maskedEmail(value)))));
        let displayPhone = this.phoneNoList.map((value) => (h("div", { class: value },
            h("lab", { htmlFor: value },
                h("input", { class: "form-check-input", type: "radio", name: "drone", value: value, onInput: (e) => this.setValue(e), style: inputStyle }),
                this.phoneMasked(value)))));
        return (h("div", null, this.redirectTo === true ? (h("div", null,
            h("center", null,
                h("h3", { class: "" }, this.language === "en" ? (h("span", { style: textStyle }, this.step2_heading)) : (h("span", { style: textStyle }, this.step2_headingSP)))),
            h("div", { class: "lineClass", style: line }),
            h("center", null, this.language === "en" ? (h("div", { style: contentStyle }, this.step2_instruction)) : (h("div", { style: contentStyle }, this.step2_instructionSP))),
            h("div", { class: "row mt-4" },
                h("div", { class: "flex-container" }, vectorInput)),
            h("center", { class: "errormsg", style: errorStyle }, this.errorOTP !== null ? h("p", null, this.errorOTP) : null),
            h("center", null,
                h("div", { class: "buttonsGroup" },
                    h("button", { class: "emailButton", style: buttonStyle, onClick: this.goBack.bind(this) }, this.language === "en" ? h("a", null, "Previous") : h("a", null, "Previo")),
                    h("button", { class: "emailButton", style: buttonStyle, onClick: this.verifyOTP.bind(this) }, this.language === "en" ? (h("a", null, "Verify now")) : (h("a", null, "Verifica ahora"))))),
            h("center", null,
                h("a", { href: "#", style: contentStyle, onClick: () => this.firstPage() }, this.language === "en" ? (h("a", null, "Resend code")) : (h("a", null, "Reenviar codigo")))))) : (h("div", { class: "container mt-5" },
            h("center", null,
                h("h1", { style: textStyle }, this.language === "en" ? (h("span", null, this.step1_heading)) : (h("span", null, this.step1_headingSP)))),
            h("div", { style: line }),
            h("center", null,
                h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (h("span", null, this.step1_description)) : (h("span", null, this.step1_descriptionSP)))),
            h("center", null,
                h("div", { class: "text-center", style: contentStyle }, this.language === "en" ? (h("span", null, this.step1_instruction)) : (h("span", null, this.step1_instructionSP)))),
            h("center", null,
                h("div", { class: "flex-container" },
                    h("div", { class: "emailandphone", style: innerContent },
                        displayEmail,
                        displayPhone))),
            h("center", { class: "errormsg" }, this.errorMessage !== "" || this.errorMessage !== null ? (h("p", null, this.errorMessage)) : null),
            h("center", null,
                h("div", { class: "buttonsGroup" },
                    h("button", { class: "emailButton", style: buttonStyle }, this.language === "en" ? (h("span", null, "Previous")) : (h("span", null, "Previo"))),
                    h("button", { class: "emailButton", style: buttonStyle, onClick: this.check.bind(this) }, this.language === "en" ? (h("span", null, "Send OTP")) : (h("span", null, "Enviar OTP"))))),
            h("center", null,
                h("a", { style: contentStyle, href: "#" }, this.language === "en" ? (h("span", null, "I don't see my number or email")) : (h("span", null, "No veo mi n\u00FAmero o correo electr\u00F3nico"))))))));
    }
    static get is() { return "otp-web-component"; }
    static get originalStyleUrls() { return {
        "$": ["my-component.css"]
    }; }
    static get styleUrls() { return {
        "$": ["my-component.css"]
    }; }
    static get properties() { return {
        "callBack": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "Function",
                "resolved": "Function",
                "references": {
                    "Function": {
                        "location": "global"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        },
        "name": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false
        },
        "input": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "input",
            "reflect": false
        },
        "myInnerStrings": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "Array<string>",
                "resolved": "string[]",
                "references": {
                    "Array": {
                        "location": "global"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        },
        "api": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "api",
            "reflect": false
        },
        "otpApi": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "otp-api",
            "reflect": false
        },
        "color": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "color",
            "reflect": false
        },
        "fontfamily": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "fontfamily",
            "reflect": false
        },
        "headingfontsize": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "headingfontsize",
            "reflect": false
        },
        "textfontsize": {
            "type": "any",
            "mutable": false,
            "complexType": {
                "original": "any",
                "resolved": "any",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "textfontsize",
            "reflect": false
        },
        "size": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "size",
            "reflect": false
        },
        "buttonColor": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "button-color",
            "reflect": false
        },
        "language": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "language",
            "reflect": false
        },
        "callback": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "() => void",
                "resolved": "() => void",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        }
    }; }
    static get states() { return {
        "step1_heading": {},
        "step1_headingSP": {},
        "step1_instruction": {},
        "step1_instructionSP": {},
        "step1_description": {},
        "step1_descriptionSP": {},
        "step2_heading": {},
        "step2_headingSP": {},
        "toggle": {},
        "sendOTP": {},
        "errorMessage": {},
        "emailList": {},
        "phoneNoList": {},
        "redirectTo": {},
        "otpCode": {},
        "errorOTP": {},
        "otpValue": {},
        "checkToMove": {},
        "step2_instruction": {},
        "step2_instructionSP": {}
    }; }
    static get watchers() { return [{
            "propName": "input",
            "methodName": "parseMyArrayPropTo"
        }]; }
    static get listeners() { return [{
            "name": "event.keydoen.enter",
            "method": "pageFirst",
            "target": undefined,
            "capture": false,
            "passive": false
        }, {
            "name": "event.keydown.enter",
            "method": "handleOtp",
            "target": undefined,
            "capture": false,
            "passive": false
        }, {
            "name": "event.keydown.enter",
            "method": "verifyOTP",
            "target": undefined,
            "capture": false,
            "passive": false
        }]; }
}
